C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C    THE REST OF THE CODE CONTAINS PARAMETRIZATIONS FOR
C    STRUCTURE FUNCTIONS
C    (COURTESY TO D.Y.BARDIN, G.LEVMAN)
C
      SUBROUTINE STRFBS(X,Q2,AF1,AF2)
C
C   CALLED FOR IPART > 2000
C   CALCULATION OF STRUCTURE FUNCTIONS F1 AND F2
C   FOR LARGE Q2 THE PARTON MODEL RELATIONS ARE USED WITH
C   PARAMETRIZATIONS DETERMINED BY (IPART-2000)
C   FOR SMALL Q2 THE PARAMETRIZATIONS BY STEIN ET AL. AND BRASSE
C   ARE USED (SUBROUTINES FROM A.AKHUNDOV, D. BARDIN ET AL.: TERAD91)
C
      IMPLICIT DOUBLE PRECISION (A-H,M,O-Z)
C...DECLARATIONS FOR HERACLES
      COMMON /HSELAB/ SP,EELE,PELE,EPRO,PPRO
      COMMON /HSGSW1/ MEI,MEF,MQI,MQF,MEI2,MEF2,MQI2,MQF2,MPRO,MPRO2
      COMMON /HSKNST/ PI,ALPHA,ALP1PI,ALP2PI,ALP4PI,E,GF,SXNORM,SX1NRM
C...DECLARATIONS FOR STRUCTURE FUNCTIONS PARAMETRIZATIONS
C...SUBROUTINES TAKEN FROM A.AKHUNDOV ET AL. (TERAD91)
      COMMON /HSRADC/ AMP , AMP2,RPI ,RPI2 , ALFA, AML , AML2
      COMMON /HSRADF/ AP,AP2,AP4,AL2,AL4,ALPS,CALPI,W2PIT,W2TR,TTR
      COMMON /HSSINC/ SS,SAP,SAMP2,SW2PIT,SW2MIN,SW2TR
      REAL*4 SS,SAP,SAMP2,SW2PIT,SW2MIN,SW2TR
C...LOCAL DECLARATIONS
      LOGICAL LFIRST
      DATA W2MIN/1.2321D0/
      DATA LFIRST/.TRUE./
C...
C...INITIALIZATION
      IF (LFIRST) THEN
        LFIRST=.FALSE.
CHS                                                   *** CHECK THIS ***
        IMODEL=0
CHS
*
* SETTING OF CONSTANTS
        RPI =PI
        RPI2=PI*PI
        AML=MEI
        AMP=MPRO
        AML2=MEI2
        AMP2=MPRO2
        ALFA =ALPHA
        ALFAI=ALPHA
        CALPI=1D0/ALFA/PI
        AP  = 2D0*AMP
        AP2 = 2D0*AMP2
        AP4 = 4D0*AMP2
        AL2 = 2D0*AML2
        AL4 = 4D0*AML2
        ALPS= 4D0*AML2*AMP2
*
        S=SP
        SS=SNGL(S-AMP2-AML2)
        SAP = SNGL(AP)
        SAMP2=SNGL(AMP2)
*
C       W2TR =  4D0
C       TTR   = 6D0
C       W2TR =  0D0
C       TTR   = 0D0
* THE TWO FOREGOING PARAMETERS MAY BE USED TO SUBDIVIDE THE 2-DIMENSIO-
* NAL INTEGRATION REGION INTO UP TO 3 PARTS. FOR W2TR=TTR=0D0, THERE
* IS ONLY ONE REGION. CHOOSING THE PARAMETER TTR (IN GEV**2) > 0, ONE
* SPLITS THE REGION INTO TWO PARTS, ONE OF THEM WITH SMALL T=Q'**2
* WHERE THE STRUCTURE FUNCTIONS SHOULD HAVE A SPECIAL BEHAVIOUR.
* IN ADDITION, THIS REGION OF SMALL T CAN BE SPLIT INTO 2 SUBREGIONS
* BY A CHOICE OF THE PARAMETER W2TR (IN GEV**2) > M.PROTON**2.
* THIS CAN BE USED FOR A PROPER TREATMENT OF THE RESONANCE REGION.
*
*     PION THRESHOLD
        IF(IMODEL.EQ.0) THEN
          W2PIT = 1.15184D0
            ELSE
          W2PIT = AMP2*(1D0+1D-10)
        ENDIF
        SW2PIT=SNGL(W2PIT)
        SW2MIN=SNGL(W2MIN)
        SW2TR =SNGL(W2TR )
      ENDIF

C...CALCULATION OF STRUCTURE FUNCTIONS

      W2 = (1D0-X)/X*Q2 + MPRO2
      IF (W2.LT.W2TR) THEN
        CALL BRASSE(Q2,W2,ZF1,ZF2)
        ELSE
        CALL STEIN(Q2,W2,ZF1,ZF2)
      ENDIF

      AF1=ZF1
      AF2=ZF2
      END
